#include <stdio.h>
#include "shm.h"		/* for our shared mem/sem primatives */

#define SHMKEY 8101

int main(int argc, char *argv[]) {

  key_t key = SHMKEY;		/* shared key */
  char *counter;		/* shared memory */
  int num;			/* local copy */
  int i;			/* loop index */
  int incr;			/* increment or decrement */

  /* parse command line */
  if (argc != 2) {
    printf("usage: %s <num>\n", argv[0]);
    exit(1);
  }
  incr = atoi(argv[1]);
  printf("incr: %d\n", incr);

  /* create or link to the shared memory counter */
  /* we need 6 digits plus a null */
  if ((counter = (char *) shmcreate(key, 6*sizeof(char))) == NULL) {
    perror("shmcreate");
    exit(1);
  }

  /* hack to initialize the shared memory */
  sscanf(counter, "%d", &num);
  if ((incr > 0) || (num < -20000 || num > 20000)) 
    sprintf(counter, "0");

  for (i=0; i<20000; i++) {

    /** begin critical region **/
  
    /* get old value */
    sscanf(counter, "%d", &num);
    num = num + incr;
    sprintf(counter, "%d\n", num);
    printf("%d\n", num);

    /** end critical region **/

  }

  /* remove the shared memory */
  shmdelete(counter);

  exit(0);

}
